﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using igGrid_Sample_MVC5.Models;
using Infragistics.Web.Mvc;

namespace igGrid_Sample_MVC5.Controllers
{
	public class HomeController : Controller
	{
		//
		// GET: /Home/
		public ActionResult Index(string id)
		{
			GridModel model = new GridModel();
			model.ID = "grid1";
			model.Height = "700px";
			model.PrimaryKey = "ProductID";
			model.AutoGenerateColumns = false;

			model.Columns = new List<GridColumn>();
			model.Columns.Add(new GridColumn("ProductID", "ProductID", "number", null));
			model.Columns.Add(new GridColumn("Name", "Name", "string", null));
			model.Columns.Add(new GridColumn("ReleaseDate", "ReleaseDate", "date", null));

			model.Features = new List<GridFeature>();

			GridGroupBy groupBy = new GridGroupBy();
			groupBy.Type = OpType.Local;
			groupBy.ColumnSettings = new List<GroupByColumnSetting>();

			GroupByColumnSetting groupBySetting = new GroupByColumnSetting();
			groupBySetting.ColumnKey = "ReleaseDate";
			groupBySetting.CompareFunc = "gridCompareDateFunc";

			groupBy.ColumnSettings.Add(groupBySetting);

			model.Features.Add(groupBy);

			model.DataSource = Product.GetProductData().AsQueryable();
			model.DataBind();

			return View(model);
		}

		[GridDataSourceAction]
		public ActionResult GetData()
		{
			return View(Product.GetProductData().AsQueryable());
		}
		public ActionResult Pivot()
		{
			return View();
		}

		public ActionResult Updating(string id)
		{
			return View(Product.GetProductData().AsQueryable());
		}

		public ActionResult SaveChanges()
		{
			GridModel gridModel = new GridModel();
			List<Transaction<Product>> transactions = gridModel.LoadTransactions<Product>(HttpContext.Request.Form["ig_transactions"]);

			JsonResult result = new JsonResult();
			Dictionary<string, object> response = new Dictionary<string, object>();
			response.Add("Success", true);
			response.Add("oldId", transactions[0].rowId);
			response.Add("newId", transactions[0].rowId + 100);
			result.Data = response;
			return result;
		}

		public string myFormatterFunction(string a, string b)
		{
			return string.Format("Meaning(\"{0}\", \"{1}\")", a, b);
		}
	}
}